package soln;

import java.awt.Color;
import java.io.IOException;
import java.util.Scanner;

import packageForLT05.DotView;
import packageForLT05.DotModel;

public class Labtest05_Sec03_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * [3 marks] Step 1: create an instance of a DotModel. Store the
		 * reference in a variable named "model". The API for this and other
		 * classes in this labtest can be found in the "doc" subdirectory of
		 * this package. You may use any valid in the constructor, but do not
		 * use a magic number. NB: your solution should work for *any* valid
		 * value and not just the one you select here.
		 */
		final int NUM_DOTS = 5;
		DotModel model = new DotModel(NUM_DOTS);

		/**
		 * [3 marks] Step 2: create an instance of a DotView. Use the
		 * appropriate constructor. Read the API carefully. You don't need to
		 * add the view to a JFrame. Just instantiate the view, compile and run
		 * the app.
		 * 
		 */
		DotView view = new DotView(model);

		/**
		 * [5 marks] Step 3: add code below so that the app repeatedly prompts
		 * the user for commands, in the same fashion as in DrawVersion6 (which
		 * has been included in the package "packageForLT05").
		 * 
		 * Offer the following commands:
		 * 
		 * "q" for quit - break out of the loop
		 * 
		 * "nb" for "nudge all blue dots" - this means all blue dots will be
		 * nudged. You will need to iterate over all of the dots, check each
		 * one's color and nudge it or not (accordingly), one per iteration.
		 * (You have a representation of the total number of dots from Step 1
		 * above.)
		 * 
		 * Hint: the data model provides the method getColour(int) and returns a
		 * Color object. The referent Color.BLUE refers to the colour object
		 * that corresponds to blue.
		 * 
		 * The prompts should be as follows:
		 * "Command#1 [nb=nudge all blue dots, q=quit]:"
		 * 
		 * For this step, it is suggested that you resize your eclipse window to
		 * a slightly narrower width and then reposition it to the right. That
		 * was, the GUI frame and the eclipse window will not overlap.
		 * 
		 */

		Scanner input = new Scanner(System.in);
		while (true) {
			System.out.println("Command#1 [nb=nudge all blue dots, q=quit]:");
			String userInput = input.nextLine();
			if (userInput.equals("q")) {
				break;
			}
			if (userInput.equals("nb")) {
				for (int i = 0; i < NUM_DOTS; i++) {
					if (model.getColour(i).equals(Color.BLUE))
						model.nudgeToRight(i);
				}
			}
		}

		/**
		 * [3 marks] Step 4: add another loop below that offers the following
		 * commands:
		 * 
		 * "q" for quit - break out of the loop
		 * 
		 * "n" for "nudge dots of a certain colour" - this is a general version
		 * of the command "nb" above. If the user types "n", then you need to
		 * prompt the user again and ask for the color (see prompt below). The
		 * user will then indicate which colour(s) should be nudged. The
		 * possible responses as "b" for blue, "g" for green and "r" for red or
		 * any combination of the characters "b", "g" and "r". For instance, if
		 * the user types "rgb" or "bgr" (or any order) this should means that
		 * all red, green, and blue dots will be nudged. If the user types "gb",
		 * this should cause only the green and blue dots to be nudged (but not
		 * the red).
		 * 
		 * Hint: construct separate boolean conditions for each of the colors
		 * (e.g., if the user indicated the color blue and if the current dot
		 * has blue color, and so on for each of the other two colours.). To
		 * test each colour, use the services of the "matches(String)" method of
		 * the class String (or, alternatively, use the method indexOf -- if the
		 * substring is not found, the method will return -1). If you are unsure
		 * and want to get at least part marks, then implement the code to work
		 * for the case in which the user types only one character each time
		 * (e.g., "r" or "b" or "g" but not any inputs other than this)
		 * 
		 * The prompts should be as follows:
		 * 
		 * "Command#2 [n=nudge dots of a certain colour,  q=quit]:"
		 * 
		 * "Color to nudge: "
		 */
		while (true) {
			System.out
					.println("Command#2 [n=nudge dots of a certain colour,  q=quit]:");
			String userInput = input.nextLine();
			if (userInput.equals("q")) {
				break;
			}
			if (userInput.equals("n")) {
				System.out.println("Color to nudge: ");
				String colorString = input.nextLine();
				for (int i = 0; i < NUM_DOTS; i++) {
					boolean condRed = colorString.matches(".*r.*")
							&& model.getColour(i).equals(Color.RED);
					boolean condBlue = colorString.matches(".*b.*")
							&& model.getColour(i).equals(Color.BLUE);
					boolean condGreen = colorString.matches(".*g.*")
							&& model.getColour(i).equals(Color.GREEN);
					if (condRed || condBlue || condGreen) {
						model.nudgeToRight(i);
					}
				}
			}

		}

	}
}
